/*************************************************************************
 * 
 * eCasa, Inc CONFIDENTIAL
 * __________________
 * 
 *  [2010] - [2011] eCasa,  Inc. 
 *  All Rights Reserved.
 * 
 * NOTICE:  All information contained herein is, and remains
 * the property of eCasa, inc. and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to eCasa, Inc.,
 * and its suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from eCasa, Inc.
 */

/*
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/*
 * This file is subject to the terms and conditions defined in
 * file 'LICENSE.pdf', which is part of this package.
 */

// Verion 0.9 beta

#import <UIKit/UIKit.h>
#import <MessageUI/MessageUI.h>

@interface RAZPDFDocument : NSObject <UIActionSheetDelegate, MFMailComposeViewControllerDelegate, UIPrintInteractionControllerDelegate, UIDocumentInteractionControllerDelegate>{
	// RAZPDF readonly properties
	NSInteger pdfPageCount;
	double pdfRenderTime;
	// RAZPDF properties
	NSString *pdfAuthor;
	NSString *pdfTitle;
	NSString *pdfSubject;
	NSString *pdfOwnerPassword;
	NSString *pdfUserPassword;
	BOOL pdfAllowsPrinting;
	BOOL pdfAllowsCopying;
	BOOL pdfWatermark;
	BOOL pdfAutodelete;
	// RAZPDF Mail properties
	NSString *mailSubject;
	NSArray *mailToRecipients;
	NSArray *mailCCRecipients;
	NSArray *mailBCCRecipients;
	NSString *mailMessageBody;
	NSString *mailFilename;
	BOOL isHTML;
	// UI properties
	NSString *actionSheetTitle;
	UIColor *tintColor;
	BOOL translucent;
	
@private	
	NSString *path;
	UIView *pdfView;
	CGContextRef pdfContextGlobal;
	CGFloat width;
	CGFloat height;
	UIViewController *parentViewController;
}

@property (nonatomic, retain) IBOutlet UIView *pdfView;
@property (nonatomic, assign) CGContextRef pdfContextGlobal; 
@property (nonatomic, retain) NSString *path;
@property (nonatomic, retain) NSString *mailFilename;
@property (nonatomic, assign, readonly) NSInteger pdfPageCount; 


//RAZPDFBegin Properties
@property(nonatomic, retain) NSString *pdfAuthor;
@property(nonatomic, retain) NSString *pdfTitle;
@property(nonatomic, retain) NSString *pdfSubject;
@property(nonatomic, retain) NSString *pdfOwnerPassword;
@property(nonatomic, retain) NSString *pdfUserPassword;
@property(nonatomic, assign) BOOL pdfAllowsPrinting;
@property(nonatomic, assign) BOOL pdfAllowsCopying;
@property(nonatomic, assign) BOOL pdfWatermark;
@property(nonatomic, assign) BOOL pdfAutodelete;
@property(nonatomic, assign, readonly) double pdfRenderTime;


//RAZPDFMail Properties
@property(nonatomic, retain) NSString *mailSubject;
@property(nonatomic, retain) NSArray *mailToRecipients;
@property(nonatomic, retain) NSArray *mailCCRecipients;
@property(nonatomic, retain) NSArray *mailBCCRecipients;
@property(nonatomic, retain) NSString *mailMessageBody;
@property(nonatomic, assign) BOOL isHTML;

//RAZPDF UI Properties
@property(nonatomic, retain) NSString *actionSheetTitle;
@property(nonatomic, retain) UIColor *tintColor;
@property(nonatomic, assign) BOOL translucent;
 
// local
@property (nonatomic, assign) CGFloat width;
@property (nonatomic, assign) CGFloat height;
@property (nonatomic, retain) UIViewController *parentViewController;


// Methods
- (id)initWithPath:(NSString *)path error:(NSError **)error;
+ (id)tempDocument;
- (BOOL)addPage:(UIView *)PDFView error:(NSError **)error;
- (BOOL)closePDF:(NSError **)error;
- (BOOL)deletePDF:(NSError **)error;
- (BOOL)mailPDFInViewController:(UIViewController *)inParentViewController error:(NSError **)error;
- (BOOL)printPDFInViewController:(UIViewController *)inParentViewController error:(NSError **)error;
- (BOOL)openPDFInViewController:(UIViewController *)inParentViewController error:(NSError **)error;
- (void)actionSheetInViewController:(UIViewController *)inParentViewController;


@end
